#include<windows.h>
#include<string>
#include"Board.h"

static HBITMAP ico1_hBitmap;
static HBITMAP ico2_hBitmap;
HDC ico1_hBuffer;
HDC ico2_hBuffer;
HWND m_hWnd;
HMENU m_hMenu;
WNDCLASSEX wndClass;

HFONT t_hFont;
HFONT m_hFont;
HBITMAP m_hBitmap;
HBRUSH m_grayBrush;
HBRUSH m_whiteBrush;
HBRUSH m_blackBrush;
HBRUSH m_greenBrush;
HBRUSH m_lightBlueBrush; 
Board* m_board;
HDC wDC;
HDC tDC;
HBITMAP bufferBMP;
RECT rc;
int blackCount , whiteCount;
int AniTime = 200;
auto board = m_board->getBoard();
void drawText(HDC hDC, std::wstring, RECT, UINT format = DT_LEFT);
void RefreshWindow();
void RefreshBuffer();

void DrawBuffer(HDC);
void drawText(HDC hDC,std::wstring str, RECT rc,UINT format) {
	DrawText(hDC, str.c_str(), str.length(), &rc, format);
}
void RefreshBuffer() {
	rc = { 0,0,700,480 };
	FillRect(tDC, &rc, m_grayBrush);


	// Start rendering
	SelectObject(tDC, m_hFont);
	SetBkMode(tDC, TRANSPARENT);

	board = m_board->getBoard();
	blackCount = 0, whiteCount = 0;
	ico1_hBuffer = CreateCompatibleDC(tDC);
	SelectObject(ico1_hBuffer, ico1_hBitmap);
	ico2_hBuffer = CreateCompatibleDC(tDC);
	SelectObject(ico2_hBuffer, ico2_hBitmap);

	SelectObject(tDC, m_blackBrush);
	for (int i = 0; i < 8; ++i) {
		for (int j = 0; j < 8; ++j) {
			if (board[i][j] == BlockStatus::BLACK) {
				//Ellipse(tDC, j * 50 + 25, i * 50 + 25, j * 50 + 75, i * 50 + 75);
				BitBlt(tDC, j * 50 + 25, i * 50 + 25, 50, 50, ico2_hBuffer, 0, 0, SRCCOPY);
				++blackCount;
			}
		}
	}
	SelectObject(tDC, m_whiteBrush);
	for (int i = 0; i < 8; ++i) {
		for (int j = 0; j < 8; ++j) {
			if (board[i][j] == BlockStatus::WHITE) {
				//Ellipse(tDC, j * 50 + 25, i * 50 + 25, j * 50 + 75, i * 50 + 75);
				BitBlt(tDC, j * 50 + 25, i * 50 + 25, 50, 50, ico1_hBuffer, 0, 0, SRCCOPY);
				++whiteCount;
			}
		}
	}
	DeleteDC(ico1_hBuffer);
	DeleteDC(ico2_hBuffer);
	SelectObject(tDC, m_lightBlueBrush);
	for (int i = 0; i < 8; ++i) {
		for (int j = 0; j < 8; ++j) {
			if (board[i][j] == BlockStatus::AVAILABLE) {
				Ellipse(tDC, j * 50 + 40, i * 50 + 40, j * 50 + 60, i * 50 + 60);
			}
		}
	}

	for (int i = 0; i < 9; ++i) {
		MoveToEx(tDC, i * 50 + 25, 25, NULL);
		LineTo(tDC, i * 50 + 25, 425);
	}
	for (int i = 0; i < 9; ++i) {
		MoveToEx(tDC, 25, i * 50 + 25, NULL);
		LineTo(tDC, 425, i * 50 + 25);
	}
	SetTextColor(tDC, RGB(0, 0, 0));
	drawText(tDC, std::to_wstring(blackCount), { 490,25,545,75 }, DT_CENTER);
	SetTextColor(tDC, RGB(0, 255, 0));
	drawText(tDC, L":", { 545,25,555,75 }, DT_CENTER);
	SetTextColor(tDC, RGB(255, 255, 255));
	drawText(tDC, std::to_wstring(whiteCount), { 555,25,610,75 }, DT_CENTER);

}
void RefreshWindow() {
	RefreshBuffer();
	DrawBuffer(GetDC(m_hWnd));

	if (m_board->isGameOver) {
		if (m_board->isFull && whiteCount < blackCount || whiteCount == 0) {
			MessageBox(m_hWnd, TEXT("You Win!"),
				TEXT("Reversi"), MB_OK | MB_ICONASTERISK);
			m_board->restart();
			RefreshWindow();
			return;
		}
		else if (m_board->isFull && whiteCount == blackCount) {
			MessageBox(m_hWnd, TEXT("Draw!"),
				TEXT("Reversi"), MB_OK | MB_ICONASTERISK);
			m_board->restart();
			RefreshWindow();
			return;
		}
		else if ((m_board->isFull && whiteCount > blackCount) || blackCount == 0) {
			MessageBox(m_hWnd, TEXT("You Lose!\n\nGenkaiya!"),
				TEXT("Reversi"), MB_OK | MB_ICONASTERISK);
			m_board->restart();
			RefreshWindow();
			return;
		}
	}
	else if (m_board->isnoAvailable) {
		MessageBox(m_hWnd, TEXT("Since you have no more moves, AI goes again."),
			TEXT("Reversi"), MB_OK | MB_ICONEXCLAMATION);
		m_board->robot();
		m_board->setAvailable();
		RefreshWindow();
		return;
	}
}
void DrawBuffer(HDC wDC) {
	BitBlt(wDC, 0, 0,
		700, 600, tDC, 0, 0, SRCCOPY);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	PAINTSTRUCT ps;
	switch (message) {
	case WM_LBUTTONDOWN:
		{
			auto Pos = MAKEPOINTS(lParam);
			int xPos = Pos.x;
			int yPos = Pos.y;
			if ((xPos>=25 && xPos<=425) && (yPos>=25 && yPos<=425) ) {
				// in rect
				xPos -= 25;
				xPos /= 50;
				yPos -= 25;
				yPos /= 50;
				if (m_board->getBoard()[yPos][xPos] != BlockStatus::AVAILABLE) {
					return 0;
				}
				m_board->mouseClick(yPos, xPos);
				RefreshWindow();
				Sleep(AniTime);
				m_board->robot();
				m_board->setAvailable();
				RefreshWindow();
			}
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case 101:
			m_board->restart();
			RefreshWindow();
			break;
		case 102:
			PostMessage(m_hWnd, WM_CLOSE, 0, 0);
			break;
		case 201:
			AniTime = 100;
			CheckMenuItem(m_hMenu, 201, MF_BYCOMMAND | MFS_CHECKED);
			CheckMenuItem(m_hMenu, 202, MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(m_hMenu, 203, MF_BYCOMMAND | MFS_UNCHECKED);
			RefreshWindow();
			break;
		case 202:
			AniTime = 200;
			CheckMenuItem(m_hMenu, 201, MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(m_hMenu, 202, MF_BYCOMMAND | MFS_CHECKED);
			CheckMenuItem(m_hMenu, 203, MF_BYCOMMAND | MFS_UNCHECKED);
			RefreshWindow();
			break;
		case 203:
			AniTime = 400;
			CheckMenuItem(m_hMenu, 201, MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(m_hMenu, 202, MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(m_hMenu, 203, MF_BYCOMMAND | MFS_CHECKED);
			RefreshWindow();
			break;
		case 301:
			MessageBox(m_hWnd, TEXT("Genkaiya-chan Reversi\nVersion 2.0\n\n(C)2022 TMK"),
				TEXT("About"), MB_OK | MB_ICONASTERISK);
			break;
		}
		break;
	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE) {
			m_board->restart();
			RefreshWindow();
		}
		break;
	case WM_MOUSEMOVE:
	{
		auto Pos = MAKEPOINTS(lParam);
		int xPos = Pos.x;
		int yPos = Pos.y;
		if ((xPos >= 25 && xPos <= 425) && (yPos >= 25 && yPos <= 425)) {
			// in rect
			xPos -= 25;
			xPos /= 50;
			yPos -= 25;
			yPos /= 50;
			if (m_board->getBoard()[yPos][xPos] == BlockStatus::AVAILABLE) {
				HCURSOR cur = LoadCursor(NULL, IDC_HAND);
				SetCursor(cur);
			}
		}
		else {
			HCURSOR cur = LoadCursor(NULL, IDC_ARROW);
			SetCursor(cur);
		}
	}
	break;
	case WM_CREATE:
		m_whiteBrush = CreateSolidBrush(RGB(255, 255, 255));
		m_blackBrush = CreateSolidBrush(RGB(0, 0, 0));
		m_grayBrush = CreateSolidBrush(RGB(0, 128, 0));
		m_greenBrush = CreateSolidBrush(RGB(0, 255, 00));
		m_lightBlueBrush = CreateSolidBrush(RGB(0xBE, 0xEF, 0xFF));

		m_board = new Board;

		ico1_hBitmap = LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance, TEXT("ICO1"));
		ico2_hBitmap = LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance, TEXT("ICO2"));
		t_hFont = CreateFont(
			20, // logical height of font height
			0, // logical average character width
			0, // angle of escapement
			0, // base-line orientation angle
			FW_LIGHT, // font weight
			0, // italic attribute flag
			0, // underline attribute flag
			0, // strikeout attribute flag
			DEFAULT_CHARSET, // character set identifier
			OUT_DEFAULT_PRECIS, // output precision
			CLIP_CHARACTER_PRECIS, // clipping precision
			DEFAULT_QUALITY, // output quality
			DEFAULT_PITCH | FF_DONTCARE, // pitch and family
			L"" // pointer to typeface name string
		);

		m_hFont = CreateFont(
			50, // logical height of font height
			0, // logical average character width
			0, // angle of escapement
			0, // base-line orientation angle
			FW_LIGHT, // font weight
			0, // italic attribute flag
			0, // underline attribute flag
			0, // strikeout attribute flag
			DEFAULT_CHARSET, // character set identifier
			OUT_DEFAULT_PRECIS, // output precision
			CLIP_CHARACTER_PRECIS, // clipping precision
			DEFAULT_QUALITY, // output quality
			DEFAULT_PITCH | FF_DONTCARE, // pitch and family
			L"" // pointer to typeface name string
		);
		wDC = GetDC(m_hWnd);
		bufferBMP = CreateCompatibleBitmap(wDC, 700, 480);
		tDC = CreateCompatibleDC(wDC);
		SelectObject(tDC, bufferBMP);
		RefreshBuffer();
		break;
	case WM_DESTROY:
		delete m_board;
		DeleteObject(m_hFont);
		DeleteObject(t_hFont);
		DeleteObject(m_blackBrush);
		DeleteObject(m_whiteBrush);
		DeleteObject(m_grayBrush);
		DeleteObject(m_lightBlueBrush);
		DeleteObject(m_greenBrush);
		UnregisterClass(L"Reversi", wndClass.hInstance);
		DeleteObject(tDC);
		DeleteObject(bufferBMP);
		DeleteObject(ico1_hBitmap);
		DeleteObject(ico2_hBitmap);
		ReleaseDC(m_hWnd, wDC);
		PostQuitMessage(0);
		break;
	case WM_PAINT:
		wDC = BeginPaint(m_hWnd, &ps);

		DrawBuffer(wDC);
		EndPaint(m_hWnd, &ps);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow) {

	MSG msg;
	wndClass = { 0 };
	wndClass.cbSize = sizeof(WNDCLASSEX);
	wndClass.style = CS_HREDRAW | CS_VREDRAW;

	wndClass.lpfnWndProc = WndProc;
	wndClass.cbClsExtra = 0;
	wndClass.cbWndExtra = 0;
	wndClass.hInstance = hInstance;
	wndClass.hIcon = LoadIcon(hInstance, TEXT("REVERSI"));
	wndClass.hIconSm = wndClass.hIcon;
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = (HBRUSH)CreateSolidBrush(RGB(0, 128, 0));
	wndClass.lpszMenuName = NULL;
	wndClass.lpszClassName = TEXT("Reversi");
	RegisterClassEx(&wndClass);

	m_hMenu = LoadMenu(hInstance, TEXT("WNDMENU"));

	RECT clientRect; 
	clientRect.left = 0;
	clientRect.top = 0;  
	clientRect.right = 700;
	clientRect.bottom = 480; 
	AdjustWindowRect(
		&clientRect,
		WS_OVERLAPPEDWINDOW & ~WS_MAXIMIZEBOX, 
		TRUE
	);
	m_hWnd = CreateWindow(
		TEXT("Reversi"),
		TEXT("Genkaiya-chan Reversi"),
		WS_OVERLAPPEDWINDOW & ~WS_MAXIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		clientRect.right - clientRect.left,
		clientRect.bottom - clientRect.top,
		NULL,
		m_hMenu,
		hInstance,
		NULL); 
	if (m_hWnd == NULL) return -1;

	ShowWindow(m_hWnd, SW_SHOW);
	UpdateWindow(m_hWnd);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;

	return 0;
}
